/*
 * 3DS OUTSCALE API
 *
 * Welcome to the 3DS OUTSCALE's API documentation.<br /><br />  The 3DS OUTSCALE API enables you to manage your resources in the 3DS OUTSCALE Cloud. This documentation describes the different actions available along with code examples.<br /><br />  Note that the 3DS OUTSCALE Cloud is compatible with Amazon Web Services (AWS) APIs, but some resources have different names in AWS than in the 3DS OUTSCALE API. You can find a list of the differences [here](https://wiki.outscale.net/display/EN/3DS+OUTSCALE+APIs+Reference).<br /><br />  You can also manage your resources using the [Cockpit](https://wiki.outscale.net/display/EN/About+Cockpit) web interface.
 *
 * API version: 1.2
 * Contact: support@outscale.com
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package osc
// OsuExport Information about the OSU export.
type OsuExport struct {
	// The format of the export disk (`qcow2` \\| `vdi` \\| `vmdk`).
	DiskImageFormat string `json:"DiskImageFormat"`
	OsuApiKey OsuApiKey `json:"OsuApiKey,omitempty"`
	// The name of the OSU bucket you want to export the object to.
	OsuBucket string `json:"OsuBucket"`
	// The URL of the manifest file.
	OsuManifestUrl string `json:"OsuManifestUrl,omitempty"`
	// The prefix for the key of the OSU object. This key follows this format: `prefix + object_export_task_id + '.' + disk_image_format`.
	OsuPrefix string `json:"OsuPrefix,omitempty"`
}
